<template>
  <b-row align-v="stretch" class="cardRow">
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(0)"
      :size="columnSizes[0]"
      :title="$t('availableapplicationprofiles').toString()"
      @isCollapsing="handleCollapse(0)"
    >
      <APSelection
        :selected-application-profile="applicationProfile"
        :session-stored-application-profiles="sessionStoredApplicationProfiles"
        :token="token"
        @emptyApplicationProfile="emptyApplicationProfile"
        @selectApplicationProfile="selectApplicationProfile"
      />
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(1)"
      :size="columnSizes[1]"
      :title="$t('vocabulary').toString()"
      @isCollapsing="handleCollapse(1)"
    >
      <TermSelection
        :readonly="currentReadonly"
        @addVocabularyTerm="addVocabularyTerm"
      />
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :droppable="true"
      :is-collapsed="collapsedList.includes(2)"
      :size="columnSizes[2]"
      :title="$t('detailview').toString()"
      @drop="onDrop"
      @isCollapsing="handleCollapse(2)"
    >
      <APRepresentation
        :application-profile="currentApplicationProfile"
        :base-application-profile="applicationProfile"
        :base-definition="definition"
        :complete-application-profile="completeApplicationProfile"
        :definition="currentDefinition"
        :interactive="interactive"
        :querying-application-profile="queryingApplicationProfile"
        :readonly="currentReadonly"
        :selected-property="selectedProperty"
        @openEditModal="openEditModal"
        @removeProperty="removeProperty"
        @selectProperty="selectProperty"
        @switchDisplayedApplicationProfile="switchDisplayedApplicationProfile"
        @switchInteractivity="switchInteractivity"
        @textDefinitionUpdate="textDefinitionUpdate"
      />
    </AimsCollapsibleColumn>
    <AimsCollapsibleColumn
      :is-collapsed="collapsedList.includes(3)"
      :size="columnSizes[3]"
      :title="$t('properties').toString()"
      @isCollapsing="handleCollapse(3)"
    >
      <PropertyDefinition
        :application-profile="currentApplicationProfile"
        :definition="currentDefinition"
        :readonly="currentReadonly"
        :selected-property="selectedProperty"
        @updateDefinition="updateDefinition"
      />
    </AimsCollapsibleColumn>
  </b-row>
</template>

<script lang="ts">
import type { ApplicationProfile } from "@/types/application-profile";
import type VocabularyTerm from "@/types/vocabulary-term";
import type { Dataset, Quad_Subject } from "@rdfjs/types";

import { useColumns } from "@/util/columnSizes";

const defaultColumnSizes = [3, 2, 4, 3];
const growOrder = [2, 0, 1, 3];

import AimsCollapsibleColumn from "@/components/Layout/AimsCollapsibleColumn.vue";

import { defineComponent, type PropType } from "vue";

export default defineComponent({
  name: "HomeView",
  components: {
    AimsCollapsibleColumn,
  },
  props: {
    applicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    completeApplicationProfile: {
      required: true,
      type: Object as PropType<{
        definition: Dataset;
        inheritedParts: Record<
          string,
          {
            applicationProfile: ApplicationProfile;
            definition: Dataset;
          }
        >;
      }>,
    },
    currentApplicationProfile: {
      required: true,
      type: Object as PropType<ApplicationProfile>,
    },
    currentDefinition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    currentReadonly: {
      default: false,
      type: Boolean,
    },
    definition: {
      required: true,
      type: Object as PropType<Dataset>,
    },
    interactive: {
      default: true,
      type: Boolean,
    },
    queryingApplicationProfile: {
      default: false,
      type: Boolean,
    },
    readonly: {
      default: false,
      type: Boolean,
    },
    selectedProperty: {
      required: true,
      type: Object as PropType<Quad_Subject>,
    },
    sessionStoredApplicationProfiles: {
      required: false,
      default: 0,
      type: Number,
    },
    token: {
      default: "",
      type: String,
    },
  },
  setup() {
    const { collapsedList, columnSizes, handleCollapse } = useColumns(
      defaultColumnSizes,
      growOrder,
      "home",
    );
    return { collapsedList, columnSizes, handleCollapse };
  },
  methods: {
    addVocabularyTerm(vocabularyTerm: VocabularyTerm) {
      this.$emit("addVocabularyTerm", vocabularyTerm);
    },
    emptyApplicationProfile() {
      this.$emit("emptyApplicationProfile");
    },
    onDrop(event: DragEvent) {
      if (event.dataTransfer !== null && !this.currentReadonly) {
        const vocabularyTermString =
          event.dataTransfer.getData("vocabularyTerm");
        // TODO: Check if it is really a VocabularyTerm
        const vocabularyTerm = JSON.parse(
          vocabularyTermString,
        ) as VocabularyTerm;
        this.$emit("addVocabularyTerm", vocabularyTerm);
      }
    },
    openEditModal() {
      this.$emit("openEditModal");
    },
    removeProperty(property: Quad_Subject) {
      this.$emit("removeProperty", property);
    },
    selectApplicationProfile(selectedApplicationProfile: ApplicationProfile) {
      this.$emit("selectApplicationProfile", selectedApplicationProfile);
    },
    selectProperty(property: Quad_Subject) {
      this.$emit("selectProperty", property);
    },
    switchDisplayedApplicationProfile(displayedApplicationProfile: string) {
      this.$emit(
        "switchDisplayedApplicationProfile",
        displayedApplicationProfile,
      );
    },
    switchInteractivity() {
      this.$emit("switchInteractivity");
    },
    textDefinitionUpdate(
      textDefinition: string,
      mimeType = "application/n-quads",
    ) {
      this.$emit("textDefinitionUpdate", textDefinition, mimeType);
    },
    updateDefinition() {
      this.$emit("updateDefinition");
    },
  },
});
</script>
